MMEvents.createStructures(event => {
  // Dissolver Centrifuge
  event.create("mm:dissolver_centrifuge")
    .controllerId("mm:chem_dissolver_centrifuge")
    .name("Dissolver Centrifuge")
    .layout(a => {
      a.layer([
        "   ",
        " L ",
        "   "
      ])
      .layer([
        "RRR",
        "RBR",
        "RRR"
      ])
      .layer([
        "RER",
        "ISU",
        "RZR"
      ])
      .layer([
        "RFR",
        "DSD",
        "RCR"
      ])
      .layer([
        "RRR",
        "RRR",
        "RRR"
      ])
      .key("S", { block: "ad_astra:encased_steel_block" })
      .key("R", { block: "ad_astra:steel_factory_block" })
      .key("Z", { block: "thermal:machine_centrifuge" })
      .key("D", { block: "alchemistry:dissolver" })
      .key("B", { block: "minecraft:redstone_block"})
      .key("F", { block: "thermal:energy_cell"})
      .key("L", { block: "scguns:treated_brass_lamp"})
      .key("E", { port: "mm:alchem_fe",  input: true  })
      .key("I", { port: "mm:centrifuge_item", input: true  })
      .key("U", { port: "mm:alchem_item", input: false })
    });

  // Chemical Compressor
  event.create("mm:chemical_compressor")
    .controllerId("mm:chem_compressor")
    .name("Chemical Compressor")
    .layout(a => {
      a.layer([
        "    ",
        " XX ",
        "    "
      ])
      .layer([
        "RRRR",
        "RLLR",
        "IRRR"
      ])
      .layer([
        "REFR",
        "TABG",
        "CORR"
      ])
      .layer([
        "RRRR",
        "RRRR",
        "RRRR"
      ])
      .key("O", { block: "scguns:treated_brass_block" })
      .key("A", { block: "alchemistry:combiner" })
      .key("B", { block: "alchemistry:compactor" })
      .key("R", { block: "ad_astra:steel_factory_block" })
      .key("L", { block: "minecraft:redstone_block"})
      .key("X", { block: "xycraft_world:lamp_rgb_glowing_white"})
      .key("D", { block: "ad_astra:encased_steel_block" })
      .key("E", { port: "mm:alchem_fe",  input: true  })
      .key("G", { block: "thermal:obsidian_glass"})
      .key("F", { block: "thermal:energy_cell"})
      .key("I", { port: "mm:cc_compressor", input: true  })
      .key("O", { port: "mm:alchem_item", input: false })
      .key("T", { port: "mm:cc_target", input: true })
    });
});